Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/fldread.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/fldread.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/fldread.F90	(revision 13727)
@@ -1004,7 +986,7 @@
          sdf(jf)%vcomp      = sdf_n(jf)%vcomp
          sdf(jf)%rotn(:)    = .TRUE.   ! pretend to be rotated -> won't try to rotate data before the first call to fld_get
-         IF( sdf(jf)%cltype(1:4) == 'week' .AND. nn_leapy == 0  )   &
+         IF( sdf(jf)%clftyp(1:4) == 'week' .AND. nn_leapy == 0  )   &
             &   CALL ctl_stop('fld_clopn: weekly file ('//TRIM(sdf(jf)%clrootname)//') needs nn_leapy = 1')
-         IF( sdf(jf)%cltype(1:4) == 'week' .AND. sdf(jf)%ln_clim )   &
+         IF( sdf(jf)%clftyp(1:4) == 'week' .AND. sdf(jf)%ln_clim )   &
             &   CALL ctl_stop('fld_clopn: weekly file ('//TRIM(sdf(jf)%clrootname)//') needs ln_clim = .FALSE.')
          sdf(jf)%nreclast   = -1 ! Set to non zero default value to avoid errors, is updated to meaningful value during fld_clopn
@@ -1032,5 +1014,5 @@
             WRITE(numout,*) '         weights: '        , TRIM( sdf(jf)%wgtname    ),   &
                &                  '   pairing: '        , TRIM( sdf(jf)%vcomp      ),   &
-               &                  '   data type: '      ,       sdf(jf)%cltype      ,   &
+               &                  '   data type: '      ,       sdf(jf)%clftyp      ,   &
                &                  '   land/sea mask:'   , TRIM( sdf(jf)%lsmname    )
             call flush(numout)
@@ -1050,13 +1032,11 @@
       !!----------------------------------------------------------------------
       TYPE( FLD ), INTENT(in   ) ::   sd        ! field with name of weights file
-      INTEGER    , INTENT(inout) ::   kwgt      ! index of weights
+      INTEGER    , INTENT(  out) ::   kwgt      ! index of weights
       !
       INTEGER ::   kw, nestid   ! local integer
-      LOGICAL ::   found        ! local logical
       !!----------------------------------------------------------------------
       !
       !! search down linked list 
       !! weights filename is either present or we hit the end of the list
-      found = .FALSE.
       !
       !! because agrif nest part of filenames are now added in iom_open
@@ -1068,15 +1048,12 @@
 #endif
       DO kw = 1, nxt_wgt-1
-         IF( TRIM(ref_wgts(kw)%wgtname) == TRIM(sd%wgtname) .AND. &
-             ref_wgts(kw)%nestid == nestid) THEN
+         IF( ref_wgts(kw)%wgtname == sd%wgtname .AND. &
+             ref_wgts(kw)%nestid  == nestid) THEN
             kwgt = kw
-            found = .TRUE.
-            EXIT
+            RETURN
          ENDIF
       END DO
-      IF( .NOT.found ) THEN
-         kwgt = nxt_wgt
-         CALL fld_weight( sd )
-      ENDIF
+      kwgt = nxt_wgt
+      CALL fld_weight( sd )
       !
    END SUBROUTINE wgt_list
@@ -1121,5 +1098,5 @@
       TYPE( FLD ), INTENT(in) ::   sd   ! field with name of weights file
       !!
-      INTEGER ::   jn         ! dummy loop indices
+      INTEGER ::   ji,jj,jn   ! dummy loop indices
       INTEGER ::   inum       ! local logical unit
       INTEGER ::   id         ! local variable id
@@ -1127,7 +1104,7 @@
       INTEGER ::   zwrap      ! local integer
       LOGICAL ::   cyclical   ! 
-      CHARACTER (len=5) ::   aname   !
-      INTEGER , DIMENSION(:), ALLOCATABLE ::   ddims
-      INTEGER,  DIMENSION(jpi,jpj) ::   data_src
+      CHARACTER (len=5) ::   clname   !
+      INTEGER , DIMENSION(4) ::   ddims
+      INTEGER                ::   isrc
       REAL(wp), DIMENSION(jpi,jpj) ::   data_tmp
       !!----------------------------------------------------------------------
@@ -1142,20 +1119,8 @@
       !! current weights file
 
-      !! open input data file (non-model grid)
-      CALL iom_open( sd%clname, inum, ldiof =  LEN(TRIM(sd%wgtname)) > 0 )
-
-      !! get dimensions: we consider 2D data as 3D data with vertical dim size = 1
-      IF( SIZE(sd%fnow, 3) > 0 ) THEN
-         ALLOCATE( ddims(4) )
-      ELSE
-         ALLOCATE( ddims(3) )
-      ENDIF
-      id = iom_varid( inum, sd%clvar, ddims )
-
-      !! close it
-      CALL iom_close( inum )
+      !! get data grid dimensions
+      id = iom_varid( sd%num, sd%clvar, ddims )
 
       !! now open the weights file
-
       CALL iom_open ( sd%wgtname, inum )   ! interpolation weights
       IF( inum > 0 ) THEN
@@ -1193,35 +1158,34 @@
          !! two possible cases: bilinear (4 weights) or bicubic (16 weights)
          id = iom_varid(inum, 'src05', ldstop=.FALSE.)
-         IF( id <= 0) THEN
-            ref_wgts(nxt_wgt)%numwgt = 4
-         ELSE
-            ref_wgts(nxt_wgt)%numwgt = 16
-         ENDIF
-
-         ALLOCATE( ref_wgts(nxt_wgt)%data_jpi(jpi,jpj,4) )
-         ALLOCATE( ref_wgts(nxt_wgt)%data_jpj(jpi,jpj,4) )
-         ALLOCATE( ref_wgts(nxt_wgt)%data_wgt(jpi,jpj,ref_wgts(nxt_wgt)%numwgt) )
+         IF( id <= 0 ) THEN   ;   ref_wgts(nxt_wgt)%numwgt = 4
+         ELSE                 ;   ref_wgts(nxt_wgt)%numwgt = 16
+         ENDIF
+
+         ALLOCATE( ref_wgts(nxt_wgt)%data_jpi(Nis0:Nie0,Njs0:Nje0,4) )
+         ALLOCATE( ref_wgts(nxt_wgt)%data_jpj(Nis0:Nie0,Njs0:Nje0,4) )
+         ALLOCATE( ref_wgts(nxt_wgt)%data_wgt(Nis0:Nie0,Njs0:Nje0,ref_wgts(nxt_wgt)%numwgt) )
 
          DO jn = 1,4
-            aname = ' '
-            WRITE(aname,'(a3,i2.2)') 'src',jn
-            data_tmp(:,:) = 0
-            CALL iom_get ( inum, jpdom_data, aname, data_tmp(:,:) )
-            data_src(:,:) = INT(data_tmp(:,:))
-            ref_wgts(nxt_wgt)%data_jpj(:,:,jn) = 1 + (data_src(:,:)-1) / ref_wgts(nxt_wgt)%ddims(1)
-            ref_wgts(nxt_wgt)%data_jpi(:,:,jn) = data_src(:,:) - ref_wgts(nxt_wgt)%ddims(1)*(ref_wgts(nxt_wgt)%data_jpj(:,:,jn)-1)
+            WRITE(clname,'(a3,i2.2)') 'src',jn
+            CALL iom_get ( inum, jpdom_global, clname, data_tmp(:,:), cd_type = 'Z' )   !  no call to lbc_lnk
+            DO_2D( 0, 0, 0, 0 )
+               isrc = NINT(data_tmp(ji,jj)) - 1
+               ref_wgts(nxt_wgt)%data_jpi(ji,jj,jn) = 1 + MOD(isrc,  ref_wgts(nxt_wgt)%ddims(1))
+               ref_wgts(nxt_wgt)%data_jpj(ji,jj,jn) = 1 +     isrc / ref_wgts(nxt_wgt)%ddims(1)
+            END_2D
          END DO
 
          DO jn = 1, ref_wgts(nxt_wgt)%numwgt
-            aname = ' '
-            WRITE(aname,'(a3,i2.2)') 'wgt',jn
-            ref_wgts(nxt_wgt)%data_wgt(:,:,jn) = 0.0
-            CALL iom_get ( inum, jpdom_data, aname, ref_wgts(nxt_wgt)%data_wgt(:,:,jn) )
+            WRITE(clname,'(a3,i2.2)') 'wgt',jn
+            CALL iom_get ( inum, jpdom_global, clname, data_tmp(:,:), cd_type = 'Z' )   !  no call to lbc_lnk
+            DO_2D( 0, 0, 0, 0 )
+               ref_wgts(nxt_wgt)%data_wgt(ji,jj,jn) = data_tmp(ji,jj)
+            END_2D
          END DO
          CALL iom_close (inum)
  
          ! find min and max indices in grid
-         ref_wgts(nxt_wgt)%botleft(1) = MINVAL(ref_wgts(nxt_wgt)%data_jpi(:,:,:))
-         ref_wgts(nxt_wgt)%botleft(2) = MINVAL(ref_wgts(nxt_wgt)%data_jpj(:,:,:))
+         ref_wgts(nxt_wgt)%botleft( 1) = MINVAL(ref_wgts(nxt_wgt)%data_jpi(:,:,:))
+         ref_wgts(nxt_wgt)%botleft( 2) = MINVAL(ref_wgts(nxt_wgt)%data_jpj(:,:,:))
          ref_wgts(nxt_wgt)%topright(1) = MAXVAL(ref_wgts(nxt_wgt)%data_jpi(:,:,:))
          ref_wgts(nxt_wgt)%topright(2) = MAXVAL(ref_wgts(nxt_wgt)%data_jpj(:,:,:))
@@ -1247,6 +1211,4 @@
          CALL ctl_stop( '    fld_weight : unable to read the file ' )
       ENDIF
-
-      DEALLOCATE (ddims )
       !
    END SUBROUTINE fld_weight
@@ -1281,7 +1243,9 @@
       SELECT CASE( SIZE(zfieldo(jpi1_lsm:jpi2_lsm,jpj1_lsm:jpj2_lsm,:),3) )
       CASE(1)
-         CALL iom_get( inum, jpdom_unknown, 'LSM', zslmec1(jpi1_lsm:jpi2_lsm,jpj1_lsm:jpj2_lsm,1), 1, rec1_lsm, recn_lsm)
+         CALL iom_get( inum, jpdom_unknown, 'LSM', zslmec1(jpi1_lsm:jpi2_lsm,jpj1_lsm:jpj2_lsm,1),   &
+            &          1, kstart = rec1_lsm, kcount = recn_lsm)
       CASE DEFAULT
-         CALL iom_get( inum, jpdom_unknown, 'LSM', zslmec1(jpi1_lsm:jpi2_lsm,jpj1_lsm:jpj2_lsm,:), 1, rec1_lsm, recn_lsm)
+         CALL iom_get( inum, jpdom_unknown, 'LSM', zslmec1(jpi1_lsm:jpi2_lsm,jpj1_lsm:jpj2_lsm,:),   &
+            &          1, kstart = rec1_lsm, kcount = recn_lsm)
       END SELECT
       CALL iom_close( inum )
@@ -1326,14 +1290,14 @@
       !!      D. Delrosso INGV
       !!---------------------------------------------------------------------- 
-      INTEGER                      , INTENT(in   ) :: ileni,ilenj   ! lengths 
-      REAL, DIMENSION (ileni,ilenj), INTENT(in   ) :: zfieldn       ! array of forcing field with undeff for land points
-      REAL, DIMENSION (ileni,ilenj), INTENT(  out) :: zfield        ! array of forcing field
-      !
-      REAL   , DIMENSION (ileni,ilenj)   :: zmat1, zmat2, zmat3, zmat4  ! local arrays 
-      REAL   , DIMENSION (ileni,ilenj)   :: zmat5, zmat6, zmat7, zmat8  !   -     - 
-      REAL   , DIMENSION (ileni,ilenj)   :: zlsm2d                      !   -     - 
-      REAL   , DIMENSION (ileni,ilenj,8) :: zlsm3d                      !   -     -
-      LOGICAL, DIMENSION (ileni,ilenj,8) :: ll_msknan3d                 ! logical mask for undeff detection
-      LOGICAL, DIMENSION (ileni,ilenj)   :: ll_msknan2d                 ! logical mask for undeff detection
+      INTEGER                          , INTENT(in   ) :: ileni,ilenj   ! lengths 
+      REAL(wp), DIMENSION (ileni,ilenj), INTENT(in   ) :: zfieldn       ! array of forcing field with undeff for land points
+      REAL(wp), DIMENSION (ileni,ilenj), INTENT(  out) :: zfield        ! array of forcing field
+      !
+      REAL(wp) , DIMENSION (ileni,ilenj)   :: zmat1, zmat2, zmat3, zmat4  ! local arrays 
+      REAL(wp) , DIMENSION (ileni,ilenj)   :: zmat5, zmat6, zmat7, zmat8  !   -     - 
+      REAL(wp) , DIMENSION (ileni,ilenj)   :: zlsm2d                      !   -     - 
+      REAL(wp) , DIMENSION (ileni,ilenj,8) :: zlsm3d                      !   -     -
+      LOGICAL  , DIMENSION (ileni,ilenj,8) :: ll_msknan3d                 ! logical mask for undeff detection
+      LOGICAL  , DIMENSION (ileni,ilenj)   :: ll_msknan2d                 ! logical mask for undeff detection
       !!---------------------------------------------------------------------- 
       zmat8 = eoshift( zfieldn , SHIFT=-1 , BOUNDARY = (/zfieldn(:,1)/)     , DIM=2 )
@@ -1356,6 +1320,5 @@
 
 
-   SUBROUTINE fld_interp( num, clvar, kw, kk, dta,  &
-                          &         nrec, lsmfile)      
+   SUBROUTINE fld_interp( num, clvar, kw, kk, dta, nrec, lsmfile)      
       !!---------------------------------------------------------------------
       !!                    ***  ROUTINE fld_interp  ***
@@ -1375,5 +1338,6 @@
       INTEGER, DIMENSION(3) ::   rec1_lsm, recn_lsm   ! temporary arrays for start and length in case of seaoverland
       INTEGER ::   ii_lsm1,ii_lsm2,ij_lsm1,ij_lsm2    ! temporary indices
-      INTEGER ::   jk, jn, jm, jir, jjr               ! loop counters
+      INTEGER ::   ji, jj, jk, jn, jir, jjr           ! loop counters
+      INTEGER ::   ipk
       INTEGER ::   ni, nj                             ! lengths
       INTEGER ::   jpimin,jpiwid                      ! temporary indices
@@ -1386,4 +1350,5 @@
       REAL(wp),DIMENSION(:,:,:), ALLOCATABLE ::   ztmp_fly_dta                 ! local array of values on input grid     
       !!----------------------------------------------------------------------
+      ipk = SIZE(dta, 3)
       !
       !! for weighted interpolation we have weights at four corners of a box surrounding 
@@ -1415,5 +1380,5 @@
 
 
-      IF( LEN( TRIM(lsmfile) ) > 0 ) THEN
+      IF( LEN_TRIM(lsmfile) > 0 ) THEN
       !! indeces for ztmp_fly_dta
       ! --------------------------
@@ -1445,8 +1410,8 @@
          CASE(1)
               CALL iom_get( num, jpdom_unknown, clvar, ztmp_fly_dta(jpi1_lsm:jpi2_lsm,jpj1_lsm:jpj2_lsm,1),   &
-                 &                                                                nrec, rec1_lsm, recn_lsm)
+                 &          nrec, kstart = rec1_lsm, kcount = recn_lsm)
          CASE DEFAULT
               CALL iom_get( num, jpdom_unknown, clvar, ztmp_fly_dta(jpi1_lsm:jpi2_lsm,jpj1_lsm:jpj2_lsm,:),   &
-                 &                                                                nrec, rec1_lsm, recn_lsm)
+                 &          nrec, kstart = rec1_lsm, kcount = recn_lsm)
          END SELECT
          CALL apply_seaoverland(lsmfile,ztmp_fly_dta(jpi1_lsm:jpi2_lsm,jpj1_lsm:jpj2_lsm,:),                  &
@@ -1468,5 +1433,5 @@
          
          ref_wgts(kw)%fly_dta(:,:,:) = 0.0
-         CALL iom_get( num, jpdom_unknown, clvar, ref_wgts(kw)%fly_dta(jpi1:jpi2,jpj1:jpj2,:), nrec, rec1, recn)
+         CALL iom_get( num, jpdom_unknown, clvar, ref_wgts(kw)%fly_dta(jpi1:jpi2,jpj1:jpj2,:), nrec, kstart = rec1, kcount = recn)
       ENDIF
       
@@ -1474,87 +1439,95 @@
       !! first four weights common to both bilinear and bicubic
       !! data_jpi, data_jpj have already been shifted to (1,1) corresponding to botleft
-      !! note that we have to offset by 1 into fly_dta array because of halo
-      dta(:,:,:) = 0.0
-      DO jk = 1,4
-        DO jn = 1, jpj
-          DO jm = 1,jpi
-            ni = ref_wgts(kw)%data_jpi(jm,jn,jk)
-            nj = ref_wgts(kw)%data_jpj(jm,jn,jk)
-            dta(jm,jn,:) = dta(jm,jn,:) + ref_wgts(kw)%data_wgt(jm,jn,jk) * ref_wgts(kw)%fly_dta(ni+1,nj+1,:)
-          END DO
-        END DO
+      !! note that we have to offset by 1 into fly_dta array because of halo added to fly_dta (rec1 definition)
+      dta(:,:,:) = 0._wp
+      DO jn = 1,4
+         DO_3D( 0, 0, 0, 0, 1,ipk )
+            ni = ref_wgts(kw)%data_jpi(ji,jj,jn) + 1
+            nj = ref_wgts(kw)%data_jpj(ji,jj,jn) + 1
+            dta(ji,jj,jk) = dta(ji,jj,jk) + ref_wgts(kw)%data_wgt(ji,jj,jn) * ref_wgts(kw)%fly_dta(ni,nj,jk)
+         END_3D
       END DO
 
       IF(ref_wgts(kw)%numwgt .EQ. 16) THEN
 
-        !! fix up halo points that we couldnt read from file
-        IF( jpi1 == 2 ) THEN
-           ref_wgts(kw)%fly_dta(jpi1-1,:,:) = ref_wgts(kw)%fly_dta(jpi1,:,:)
-        ENDIF
-        IF( jpi2 + jpimin - 1 == ref_wgts(kw)%ddims(1)+1 ) THEN
-           ref_wgts(kw)%fly_dta(jpi2+1,:,:) = ref_wgts(kw)%fly_dta(jpi2,:,:)
-        ENDIF
-        IF( jpj1 == 2 ) THEN
-           ref_wgts(kw)%fly_dta(:,jpj1-1,:) = ref_wgts(kw)%fly_dta(:,jpj1,:)
-        ENDIF
-        IF( jpj2 + jpjmin - 1 == ref_wgts(kw)%ddims(2)+1 .AND. jpj2 .lt. jpjwid+2 ) THEN
-           ref_wgts(kw)%fly_dta(:,jpj2+1,:) = 2.0*ref_wgts(kw)%fly_dta(:,jpj2,:) - ref_wgts(kw)%fly_dta(:,jpj2-1,:)
-        ENDIF
-
-        !! if data grid is cyclic we can do better on east-west edges
-        !! but have to allow for whether first and last columns are coincident
-        IF( ref_wgts(kw)%cyclic ) THEN
-           rec1(2) = MAX( jpjmin-1, 1 )
-           recn(1) = 1
-           recn(2) = MIN( jpjwid+2, ref_wgts(kw)%ddims(2)-rec1(2)+1 )
-           jpj1 = 2 + rec1(2) - jpjmin
-           jpj2 = jpj1 + recn(2) - 1
-           IF( jpi1 == 2 ) THEN
-              rec1(1) = ref_wgts(kw)%ddims(1) - ref_wgts(kw)%overlap
-              CALL iom_get( num, jpdom_unknown, clvar, ref_wgts(kw)%col(:,jpj1:jpj2,:), nrec, rec1, recn)
-              ref_wgts(kw)%fly_dta(jpi1-1,jpj1:jpj2,:) = ref_wgts(kw)%col(1,jpj1:jpj2,:)
-           ENDIF
-           IF( jpi2 + jpimin - 1 == ref_wgts(kw)%ddims(1)+1 ) THEN
-              rec1(1) = 1 + ref_wgts(kw)%overlap
-              CALL iom_get( num, jpdom_unknown, clvar, ref_wgts(kw)%col(:,jpj1:jpj2,:), nrec, rec1, recn)
-              ref_wgts(kw)%fly_dta(jpi2+1,jpj1:jpj2,:) = ref_wgts(kw)%col(1,jpj1:jpj2,:)
-           ENDIF
-        ENDIF
-
-        ! gradient in the i direction
-        DO jk = 1,4
-          DO jn = 1, jpj
-            DO jm = 1,jpi
-              ni = ref_wgts(kw)%data_jpi(jm,jn,jk)
-              nj = ref_wgts(kw)%data_jpj(jm,jn,jk)
-              dta(jm,jn,:) = dta(jm,jn,:) + ref_wgts(kw)%data_wgt(jm,jn,jk+4) * 0.5 *         &
-                               (ref_wgts(kw)%fly_dta(ni+2,nj+1,:) - ref_wgts(kw)%fly_dta(ni,nj+1,:))
-            END DO
-          END DO
-        END DO
-
-        ! gradient in the j direction
-        DO jk = 1,4
-          DO jn = 1, jpj
-            DO jm = 1,jpi
-              ni = ref_wgts(kw)%data_jpi(jm,jn,jk)
-              nj = ref_wgts(kw)%data_jpj(jm,jn,jk)
-              dta(jm,jn,:) = dta(jm,jn,:) + ref_wgts(kw)%data_wgt(jm,jn,jk+8) * 0.5 *         &
-                               (ref_wgts(kw)%fly_dta(ni+1,nj+2,:) - ref_wgts(kw)%fly_dta(ni+1,nj,:))
-            END DO
-          END DO
-        END DO
-
-         ! gradient in the ij direction
-         DO jk = 1,4
-            DO jn = 1, jpj
-               DO jm = 1,jpi
-                  ni = ref_wgts(kw)%data_jpi(jm,jn,jk)
-                  nj = ref_wgts(kw)%data_jpj(jm,jn,jk)
-                  dta(jm,jn,:) = dta(jm,jn,:) + ref_wgts(kw)%data_wgt(jm,jn,jk+12) * 0.25 * ( &
-                               (ref_wgts(kw)%fly_dta(ni+2,nj+2,:) - ref_wgts(kw)%fly_dta(ni  ,nj+2,:)) -   &
-                               (ref_wgts(kw)%fly_dta(ni+2,nj  ,:) - ref_wgts(kw)%fly_dta(ni  ,nj  ,:)))
-               END DO
-            END DO
+         !! fix up halo points that we couldnt read from file
+         IF( jpi1 == 2 ) THEN
+            ref_wgts(kw)%fly_dta(jpi1-1,:,:) = ref_wgts(kw)%fly_dta(jpi1,:,:)
+         ENDIF
+         IF( jpi2 + jpimin - 1 == ref_wgts(kw)%ddims(1)+1 ) THEN
+            ref_wgts(kw)%fly_dta(jpi2+1,:,:) = ref_wgts(kw)%fly_dta(jpi2,:,:)
+         ENDIF
+         IF( jpj1 == 2 ) THEN
+            ref_wgts(kw)%fly_dta(:,jpj1-1,:) = ref_wgts(kw)%fly_dta(:,jpj1,:)
+         ENDIF
+         IF( jpj2 + jpjmin - 1 == ref_wgts(kw)%ddims(2)+1 .AND. jpj2 .LT. jpjwid+2 ) THEN
+            ref_wgts(kw)%fly_dta(:,jpj2+1,:) = 2.0*ref_wgts(kw)%fly_dta(:,jpj2,:) - ref_wgts(kw)%fly_dta(:,jpj2-1,:)
+         ENDIF
+         
+         !! if data grid is cyclic we can do better on east-west edges
+         !! but have to allow for whether first and last columns are coincident
+         IF( ref_wgts(kw)%cyclic ) THEN
+            rec1(2) = MAX( jpjmin-1, 1 )
+            recn(1) = 1
+            recn(2) = MIN( jpjwid+2, ref_wgts(kw)%ddims(2)-rec1(2)+1 )
+            jpj1 = 2 + rec1(2) - jpjmin
+            jpj2 = jpj1 + recn(2) - 1
+            IF( jpi1 == 2 ) THEN
+               rec1(1) = ref_wgts(kw)%ddims(1) - ref_wgts(kw)%overlap
+               CALL iom_get( num, jpdom_unknown, clvar, ref_wgts(kw)%col(:,jpj1:jpj2,:), nrec, kstart = rec1, kcount = recn)
+               ref_wgts(kw)%fly_dta(jpi1-1,jpj1:jpj2,:) = ref_wgts(kw)%col(1,jpj1:jpj2,:)
+            ENDIF
+            IF( jpi2 + jpimin - 1 == ref_wgts(kw)%ddims(1)+1 ) THEN
+               rec1(1) = 1 + ref_wgts(kw)%overlap
+               CALL iom_get( num, jpdom_unknown, clvar, ref_wgts(kw)%col(:,jpj1:jpj2,:), nrec, kstart = rec1, kcount = recn)
+               ref_wgts(kw)%fly_dta(jpi2+1,jpj1:jpj2,:) = ref_wgts(kw)%col(1,jpj1:jpj2,:)
+            ENDIF
+         ENDIF
+         !
+!!$         DO jn = 1,4
+!!$            DO_3D( 0, 0, 0, 0, 1,ipk )
+!!$               ni = ref_wgts(kw)%data_jpi(ji,jj,jn) + 1
+!!$               nj = ref_wgts(kw)%data_jpj(ji,jj,jn) + 1
+!!$               dta(ji,jj,jk) = dta(ji,jj,jk)   &
+!!$                  ! gradient in the i direction
+!!$                  &            + ref_wgts(kw)%data_wgt(ji,jj,jn+4) * 0.5_wp *                                    &
+!!$                  &                (ref_wgts(kw)%fly_dta(ni+1,nj  ,jk) - ref_wgts(kw)%fly_dta(ni-1,nj  ,jk))     &
+!!$                  ! gradient in the j direction
+!!$                  &            + ref_wgts(kw)%data_wgt(ji,jj,jn+8) * 0.5_wp *                                    &
+!!$                  &                (ref_wgts(kw)%fly_dta(ni  ,nj+1,jk) - ref_wgts(kw)%fly_dta(ni  ,nj-1,jk))     &
+!!$                  ! gradient in the ij direction
+!!$                  &            + ref_wgts(kw)%data_wgt(ji,jj,jn+12) * 0.25_wp *                                  &
+!!$                  &               ((ref_wgts(kw)%fly_dta(ni+1,nj+1,jk) - ref_wgts(kw)%fly_dta(ni-1,nj+1,jk)) -   &
+!!$                  &                (ref_wgts(kw)%fly_dta(ni+1,nj-1,jk) - ref_wgts(kw)%fly_dta(ni-1,nj-1,jk)))
+!!$            END_3D
+!!$         END DO
+         !
+         DO jn = 1,4
+            DO_3D( 0, 0, 0, 0, 1,ipk )
+               ni = ref_wgts(kw)%data_jpi(ji,jj,jn)
+               nj = ref_wgts(kw)%data_jpj(ji,jj,jn)
+               ! gradient in the i direction
+               dta(ji,jj,jk) = dta(ji,jj,jk) + ref_wgts(kw)%data_wgt(ji,jj,jn+4) * 0.5_wp *         &
+                  &                (ref_wgts(kw)%fly_dta(ni+2,nj+1,jk) - ref_wgts(kw)%fly_dta(ni  ,nj+1,jk))
+            END_3D
+         END DO
+         DO jn = 1,4
+            DO_3D( 0, 0, 0, 0, 1,ipk )
+               ni = ref_wgts(kw)%data_jpi(ji,jj,jn)
+               nj = ref_wgts(kw)%data_jpj(ji,jj,jn)
+               ! gradient in the j direction
+               dta(ji,jj,jk) = dta(ji,jj,jk) + ref_wgts(kw)%data_wgt(ji,jj,jn+8) * 0.5_wp *         &
+                  &                (ref_wgts(kw)%fly_dta(ni+1,nj+2,jk) - ref_wgts(kw)%fly_dta(ni+1,nj  ,jk))
+            END_3D
+         END DO
+         DO jn = 1,4
+            DO_3D( 0, 0, 0, 0, 1,ipk )
+               ni = ref_wgts(kw)%data_jpi(ji,jj,jn)
+               nj = ref_wgts(kw)%data_jpj(ji,jj,jn)
+               ! gradient in the ij direction
+               dta(ji,jj,jk) = dta(ji,jj,jk) + ref_wgts(kw)%data_wgt(ji,jj,jn+12) * 0.25_wp * (     &
+                  &                (ref_wgts(kw)%fly_dta(ni+2,nj+2,jk) - ref_wgts(kw)%fly_dta(ni  ,nj+2,jk)) -   &
+                  &                (ref_wgts(kw)%fly_dta(ni+2,nj  ,jk) - ref_wgts(kw)%fly_dta(ni  ,nj  ,jk)))
+            END_3D
          END DO
          !
@@ -1583,10 +1556,10 @@
       IF( .NOT. sdjf%ln_clim ) THEN   
                                          WRITE(clname, '(a,"_y",i4.4)' ) TRIM( sdjf%clrootname ), kyear    ! add year
-         IF( sdjf%cltype /= 'yearly' )   WRITE(clname, '(a, "m",i2.2)' ) TRIM( clname          ), kmonth   ! add month
+         IF( sdjf%clftyp /= 'yearly' )   WRITE(clname, '(a, "m",i2.2)' ) TRIM( clname          ), kmonth   ! add month
       ELSE
          ! build the new filename if climatological data
-         IF( sdjf%cltype /= 'yearly' )   WRITE(clname, '(a,"_m",i2.2)' ) TRIM( sdjf%clrootname ), kmonth   ! add month
-      ENDIF
-      IF(    sdjf%cltype == 'daily' .OR. sdjf%cltype(1:4) == 'week' ) &
+         IF( sdjf%clftyp /= 'yearly' )   WRITE(clname, '(a,"_m",i2.2)' ) TRIM( sdjf%clrootname ), kmonth   ! add month
+      ENDIF
+      IF(    sdjf%clftyp == 'daily' .OR. sdjf%clftyp(1:4) == 'week' ) &
          &                               WRITE(clname, '(a,"d" ,i2.2)' ) TRIM( clname          ), kday     ! add day
 
@@ -1612,5 +1585,5 @@
          IF( cl_week(ijul) == TRIM(cdday) ) EXIT
       END DO
-      IF( ijul .GT. 7 )   CALL ctl_stop( 'ksec_week: wrong day for sdjf%cltype(6:8): '//TRIM(cdday) )
+      IF( ijul .GT. 7 )   CALL ctl_stop( 'ksec_week: wrong day for sdjf%clftyp(6:8): '//TRIM(cdday) )
       !
       ishift = ijul * NINT(rday)
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/geo2ocean.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/geo2ocean.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/geo2ocean.F90	(revision 13727)
@@ -160,5 +160,5 @@
       ! (computation done on the north stereographic polar plane)
       !
-      DO_2D_00_01
+      DO_2D( 0, 0, 0, 1 )
          !                  
          zlam = plamt(ji,jj)     ! north pole direction & modulous (at t-point)
@@ -249,5 +249,5 @@
       ! =============== !
 
-      DO_2D_00_01
+      DO_2D( 0, 0, 0, 1 )
          IF( MOD( ABS( plamv(ji,jj) - plamv(ji,jj-1) ), 360. ) < 1.e-8 ) THEN
             gsint(ji,jj) = 0.
@@ -272,6 +272,6 @@
       ! =========================== !
       !           ! lateral boundary cond.: T-, U-, V-, F-pts, sgn
-      CALL lbc_lnk_multi( 'geo2ocean', gcost, 'T', -1., gsint, 'T', -1., gcosu, 'U', -1., gsinu, 'U', -1., & 
-                      &   gcosv, 'V', -1., gsinv, 'V', -1., gcosf, 'F', -1., gsinf, 'F', -1.  )
+      CALL lbc_lnk_multi( 'geo2ocean', gcost, 'T', -1.0_wp, gsint, 'T', -1.0_wp, gcosu, 'U', -1.0_wp, gsinu, 'U', -1.0_wp, & 
+                      &   gcosv, 'V', -1.0_wp, gsinv, 'V', -1.0_wp, gcosf, 'F', -1.0_wp, gsinf, 'F', -1.0_wp  )
       !
    END SUBROUTINE angle
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbc_ice.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbc_ice.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbc_ice.F90	(revision 13727)
@@ -69,5 +69,6 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   emp_oce        !: evap - precip over ocean                 [kg/m2/s]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   wndm_ice       !: wind speed module at T-point                 [m/s]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   sstfrz         !: wind speed module at T-point                 [m/s]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   sstfrz         !: sea surface freezing temperature            [degC]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   rCdU_ice       !: ice-ocean drag at T-point (<0)               [m/s]
 #endif
 
@@ -89,5 +90,5 @@
    ! variables used in the coupled interface
    INTEGER , PUBLIC, PARAMETER ::   jpl = ncat
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   u_ice, v_ice          ! jpi, jpj
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   u_ice, v_ice 
    
    ! already defined in ice.F90 for SI3
@@ -98,5 +99,5 @@
 #endif
 
-   REAL(wp), PUBLIC, SAVE ::   cldf_ice = 0.81    !: cloud fraction over sea ice, summer CLIO value   [-]
+   REAL(wp), PUBLIC, SAVE ::   pp_cldf = 0.81    !: cloud fraction over sea ice, summer CLIO value   [-]
 
    !! arrays relating to embedding ice in the ocean
@@ -131,5 +132,5 @@
          &      qemp_ice(jpi,jpj)     , qevap_ice(jpi,jpj,jpl) , qemp_oce   (jpi,jpj)     ,   &
          &      qns_oce (jpi,jpj)     , qsr_oce  (jpi,jpj)     , emp_oce    (jpi,jpj)     ,   &
-         &      emp_ice (jpi,jpj)     , sstfrz   (jpi,jpj)     , STAT= ierr(2) )
+         &      emp_ice (jpi,jpj)     , sstfrz   (jpi,jpj)     , rCdU_ice   (jpi,jpj)     , STAT= ierr(2) )
 #endif
 
@@ -167,5 +168,5 @@
    LOGICAL         , PUBLIC, PARAMETER ::   lk_si3     = .FALSE.  !: no SI3 ice model
    LOGICAL         , PUBLIC, PARAMETER ::   lk_cice    = .FALSE.  !: no CICE ice model
-   REAL(wp)        , PUBLIC, PARAMETER ::   cldf_ice = 0.81       !: cloud fraction over sea ice, summer CLIO value   [-]
+   REAL(wp)        , PUBLIC, PARAMETER ::   pp_cldf    = 0.81     !: cloud fraction over sea ice, summer CLIO value   [-]
    INTEGER         , PUBLIC, PARAMETER ::   jpl = 1 
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   u_ice, v_ice                        ! jpi, jpj
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbc_oce.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbc_oce.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbc_oce.F90	(revision 13727)
@@ -136,4 +136,5 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   atm_co2           !: atmospheric pCO2                             [ppm]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: xcplmask          !: coupling mask for ln_mixcpl (warning: allocated in sbccpl)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   cloud_fra         !: cloud cover (fraction of cloud in a gridcell) [-]
 
    !!---------------------------------------------------------------------
@@ -188,5 +189,5 @@
       !
       ALLOCATE( tprecip(jpi,jpj) , sprecip(jpi,jpj) , fr_i(jpi,jpj) ,     &
-         &      atm_co2(jpi,jpj) , tsk_m(jpi,jpj) ,                       &
+         &      atm_co2(jpi,jpj) , tsk_m(jpi,jpj) , cloud_fra(jpi,jpj),   &
          &      ssu_m  (jpi,jpj) , sst_m(jpi,jpj) , frq_m(jpi,jpj) ,      &
          &      ssv_m  (jpi,jpj) , sss_m(jpi,jpj) , ssh_m(jpi,jpj) , STAT=ierr(4) )
@@ -217,5 +218,5 @@
       !!---------------------------------------------------------------------
       zcoef = 0.5 / ( zrhoa * zcdrag )
-      DO_2D_00_00
+      DO_2D( 0, 0, 0, 0 )
          ztx = utau(ji-1,jj  ) + utau(ji,jj)
          zty = vtau(ji  ,jj-1) + vtau(ji,jj)
@@ -223,5 +224,5 @@
          wndm(ji,jj) = SQRT ( ztau * zcoef ) * tmask(ji,jj,1)
       END_2D
-      CALL lbc_lnk( 'sbc_oce', wndm(:,:) , 'T', 1. )
+      CALL lbc_lnk( 'sbc_oce', wndm(:,:) , 'T', 1.0_wp )
       !
    END SUBROUTINE sbc_tau2wnd
Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcapr.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcapr.F90	(revision 13724)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/SBC/sbcapr.F90	(revision 13727)
@@ -151,5 +151,5 @@
          IF( ln_rstart .AND. iom_varid( numror, 'ssh_ibb', ldstop = .FALSE. ) > 0 ) THEN 
             IF(lwp) WRITE(numout,*) 'sbc_apr:   ssh_ibb read in the restart file'
-            CALL iom_get( numror, jpdom_autoglo, 'ssh_ibb', ssh_ibb, ldxios = lroxios )   ! before inv. barometer ssh
+            CALL iom_get( numror, jpdom_auto, 'ssh_ibb', ssh_ibb, ldxios = lroxios )   ! before inv. barometer ssh
             !
          ELSE                                         !* no restart: set from nit000 values
